<script lang="ts">
  import { onMount } from 'svelte';
  import { KeycloakInterface, KeycloakStore } from '@auth/keycloak';
  import { getScoreboardTeams } from '@queries/Team';
  import type { Team } from '@models/Team';
  import { Gql } from '../../db';
  import { GetServiceStatus, GetServiceNames, ServiceStatusQuery } from '@models/Service';
  import type { ScoreBoardServiceStatus, Check } from '@models/Service';
  import ServiceStatusElement from './ServiceStatusElement.svelte';
  import { Table } from 'sveltestrap';

  let disposeScoresSocket;

  let scoreboardTeams: Array<Team> = Array<Team>();
  let serviceDisplayNames: Array<Partial<Check>> = Array<Partial<Check>>();
  let scoreBoardServiceStatus: Array<ScoreBoardServiceStatus>;
  $: scoreBoardServiceStatus = Array<ScoreBoardServiceStatus>();

  let authenticated: boolean = false;
  let keycloak: KeycloakInterface | undefined;

  KeycloakStore.subscribe(async (value) => {
    keycloak = value.keycloak;
    // If authentication status changed, setup teams again
    const authChanged = keycloak?.authenticated !== authenticated;
    authenticated = !!keycloak?.authenticated;
    if (authenticated && authChanged) {
      const lenTeams = scoreboardTeams?.length || 0;
      const res = await getScoreboardTeams();
      if (res && res.length > 0) {
        scoreboardTeams = res;
      }
      if (scoreboardTeams?.length !== lenTeams) {
        initialize();
      }
    }
  });

  onMount(async () => {
    initialize();
  });

  async function initialize() {
    scoreboardTeams = await getScoreboardTeams();
    scoreBoardServiceStatus = await GetServiceStatus();
    serviceDisplayNames = await GetServiceNames();

    const sink = {
      complete: () => console.debug('subscription stopped'),
      error: (err) => console.error(err),
      next: (res: { data: { scoreboard_service_status: Array<ScoreBoardServiceStatus> } }) => {
        scoreBoardServiceStatus = res.data.scoreboard_service_status;
      },
    };

    // Get the highest privileged role this user has
    const queryRole = keycloak?.getHighestPrivilegeRole();
    disposeScoresSocket = Gql.subscribe(`subscription ${ServiceStatusQuery}`, sink, { role: queryRole });
  }
</script>

<div class="service-statuses">
  <Table dark>
    <thead>
      <tr>
        <th
          ><div class="sv-row">
            <button class="sq sq-label sv-help"
              ><small>
                <span class="fa fa-circle-info" />
                <div class="sv-help-content">
                  <p class="explain">Services Legend:</p>
                  <p>
                    <span class="fa fa-arrow-circle-up text-success" />
                    <span class="explain">= running good!</span>
                  </p>
                  <p>
                    <span class="fa fa-arrow-circle-down text-danger" />
                    <span class="explain">= down/no response!</span>
                  </p>
                  <p>
                    <span class="fa fa-circle-exclamation text-warning" />
                    <span class="explain">= up but misconfigured!</span>
                  </p>
                  <p>
                    <span class="fa fa-spinner fa-pulse" style="--fa-animation-duration: 5s;" />
                    <span class="explain">= timeout!</span>
                  </p>
                  <p>
                    <span class="fa fa-question-circle text-muted" />
                    <span class="explain">= error!</span>
                  </p>
                </div>
              </small></button
            >
          </div></th
        >
        {#each serviceDisplayNames as dn}
          <th
            ><div class="sq sq-label sq-service">
              {dn.display_name}
            </div>
          </th>
        {/each}
      </tr>
    </thead>
    <tbody>
      {#each scoreboardTeams as { name }}
        <tr>
          <th scope="row">{name}</th>
          {#each scoreBoardServiceStatus as { team, result_code, participant }}
            {#if name == team.name}
              <td style="text-align: center;">
                <div>
                  {#key result_code}
                    <ServiceStatusElement status={result_code} feedback={participant?.feedback} />
                  {/key}
                </div>
              </td>
            {/if}
          {/each}
        </tr>
      {/each}
    </tbody>
  </Table>
</div>

<div class="d-flex mt-4">
  <div class="text-center m-auto alert alert-dark" role="alert">
    View the <a href="/service-feedback">Service Details page</a> for more information on why a service might be failing
  </div>
</div>
